global gHotRects, gObjects, sQTCharSprite, gHaveNavs, gCPU

on EnterG06
  if voidp(getaProp(getaProp(gStates, #BeenThere), #G06)) then
    PDARelease("J05hous.mov")
  end if
  set JenkinsPlayList to getaProp(getaProp(gObjects, #JenkinsVid), #Playlist)
  if getPos(JenkinsPlayList, "G01jen6.mov") > 0 then
    MakeDynamic(#G06NavRectParent, #State, #NavOn)
  end if
end

on setupG11A
  resetGTextFields()
  if getaProp(getaProp(gObjects, #LongTermStock), #solved) = #true then
    Startthetimer(1, "goG07B")
  end if
end

on goG07B
  genexitkf(#G07B)
end

on calcTranstoG27 Test
  if Test = #Debug then
    return [#G27A, #G27B]
  end if
  if getPos(getaProp(getaProp(gObjects, #JenkinsVid), #Playlist), "G01jen6.mov") > 0 then
    return #G27B
  else
    return #G27A
  end if
end

on resetGTextFields
  put "testPIN" into field "G11PINDisplay.txt"
  set the textFont of field "G11PINDisplay.txt" to "Monaco"
  set the textSize of field "G11PINDisplay.txt" to 12
  put "accountBalance" into field "G11BalanceDisplay.txt"
  set the textFont of field "G11BalanceDisplay.txt" to "Monaco"
  set the textSize of field "G11BalanceDisplay.txt" to 12
  put "testPIN" into field "G11LPINDisplay.txt"
  set the textFont of field "G11LPINDisplay.txt" to "Monaco"
  set the textSize of field "G11LPINDisplay.txt" to 12
  put "accountBalance" into field "G11LBalanceDisplay.txt"
  set the textFont of field "G11LBalanceDisplay.txt" to "Monaco"
  set the textSize of field "G11LBalanceDisplay.txt" to 12
  put "LStocMH" into field "G11LStocMHdata.txt"
  put "LStocOR" into field "G11LStocORdata.txt"
  put "LStocMI" into field "G11LStocMIdata.txt"
  put "LStocAT" into field "G11LStocATdata.txt"
  put "LStocHA" into field "G11LStocHAdata.txt"
  repeat with i = the number of cast "G11LStocMHdata.txt" to the number of cast "G11LStocHAdata.txt"
    set the textFont of field i to "Monaco"
    set the textSize of field i to 12
  end repeat
  clearGTextFields()
end

on clearGTextFields
  put " " into field "G11PINDisplay.txt"
  put " " into field "G11BalanceDisplay.txt"
  put " " into field "G11LPINDisplay.txt"
  put " " into field "G11LBalanceDisplay.txt"
  put " " into field "G11LStocMHdata.txt"
  put " " into field "G11LStocORdata.txt"
  put " " into field "G11LStocMIdata.txt"
  put " " into field "G11LStocATdata.txt"
  put " " into field "G11LStocHAdata.txt"
end

on setGameOver
  setaProp(getaProp(gStates, #Conditions), #LongStock, #true)
end

on setJen6Vid
  set JenkinsObj to getaProp(gObjects, #JenkinsVid)
  set JenkinsPlayList to getaProp(JenkinsObj, #Playlist)
  add(JenkinsPlayList, "G01jen6.mov")
end

on DoOverVid OBJref
  set OBj to getaProp(gObjects, OBJref)
  set timesClicked to getaProp(OBj, #timesClicked)
  if timesClicked = 0 then
    DelObjects([OBJref])
    DoCharacterMovie(#OverVid)
    GameOverEnter()
    Startthetimer(300, "setupGameOverJump", OBJref)
    MakeDynamic(OBJref, #timesClicked, timesClicked + 1)
  end if
end

on setupGameOverJump
  Startthetimer(the stopTime of sprite sQTCharSprite - the movieTime of sprite sQTCharSprite + 100, "jumpToGameOverFrame")
end

on jumpToGameOverFrame
  Jumptokey(#G07A)
end

on CalcTransToG01
  return #G01
end

on calcTranstoG01AB Test
  if Test = #Debug then
    return [#G01A, #G01B]
  end if
  if getPos(getaProp(getaProp(gObjects, #JenkinsVid), #Playlist), "G01jen6.mov") > 0 then
    return #G01B
  else
    return #G01A
  end if
end

on calcTranstoG07 Test
  if Test = #Debug then
    return [#G07, #G07B]
  end if
  if getaProp(getaProp(gStates, #Conditions), #LongStock) = #true then
    MakeDynamic(#OverNavRectParent, #State, #NavOff)
    return #G07B
  else
    if getPos(getaProp(getaProp(gObjects, #JenkinsVid), #Playlist), "G01jen6.mov") > 0 then
      MakeDynamic(#OverNavRectParent, #State, #NavOn)
      return #G07
    else
      return #G07
    end if
  end if
end

on setNurseVid
  set NurseObj to getaProp(gObjects, #NurseVid)
  set nursePlayList to getaProp(NurseObj, #Playlist)
  add(nursePlayList, "H04nsup.mov")
end

on setDoc11Vid
  set DocObj to getaProp(gObjects, #Doc11Vid)
  set DocPlayList to getaProp(DocObj, #Playlist)
  add(DocPlayList, "H11dps.mov")
end

on setJenVid
  set JenkinsObj to getaProp(gObjects, #JenkinsVid)
  set JenkinsPlayList to getaProp(JenkinsObj, #Playlist)
  add(JenkinsPlayList, "G01jen3.mov")
end

on EnterCharConditonG01
  set OBj to getaProp(gObjects, #JenkinsVid)
  set NurseObj to getaProp(gObjects, #NurseVid)
  set DocObj to getaProp(gObjects, #Doc11Vid)
  set Playlist to getaProp(OBj, #Playlist)
  set nursePlayList to getaProp(NurseObj, #Playlist)
  set DocPlayList to getaProp(DocObj, #Playlist)
  if getaProp(getaProp(gStates, #Conditions), #Defibrillate) = #true then
    MakeDynamic(#JenkinsVid, #DisplayState, 5)
    addUnique(Playlist, "G01jen6.mov")
  else
    if (getPos(Playlist, "G01jen3.mov") > 0) and (getPos(nursePlayList, "H04nsup.mov") > 0) then
      MakeDynamic(#JenkinsVid, #DisplayState, 4)
      addUnique(Playlist, "G01jenr2.mov")
    else
      if (getaProp(getaProp(gStates, #Conditions), #Defibrillate) <> #true) and (getaProp(getaProp(gStates, #BeenThere), #G01A) > 2) then
        MakeDynamic(#JenkinsVid, #DisplayState, 6)
        addUnique(Playlist, "G01jen2.mov")
      else
        if (getaProp(getaProp(gStates, #Conditions), #Defibrillate) <> #true) and (getaProp(getaProp(gStates, #BeenThere), #G01A) = 2) then
          MakeDynamic(#JenkinsVid, #DisplayState, 3)
          addUnique(Playlist, "G01jen3.mov")
        else
          if (getaProp(getaProp(gStates, #Conditions), #Defibrillate) <> #true) and (getaProp(getaProp(gStates, #BeenThere), #G01A) = 1) then
            MakeDynamic(#JenkinsVid, #DisplayState, 2)
            addUnique(Playlist, "G01jen5.mov")
          else
            if (getaProp(getaProp(gStates, #Conditions), #Defibrillate) <> #true) and (getaProp(getaProp(gStates, #BeenThere), #G01A) = 0) then
              MakeDynamic(#JenkinsVid, #DisplayState, 1)
              addUnique(Playlist, "G01jen1.mov")
            else
              setaProp(OBj, #DisplayState, #OffScreen)
            end if
          end if
        end if
      end if
    end if
  end if
  MakeDynamic(#JenkinsVid, #Playlist, Playlist)
  setaProp(OBj, #ConCount, 1)
end

on doLeafJenkins
  DelObjects([#JenkinsLeafrect])
  ReleaseUNVobject(#Leaf2Obj)
end

on Enter08JenkinsLeaf
  if getaProp(getaProp(gObjects, #Leaf2Obj), #Aquired) <> #true then
    AddObjects([#JenkinsLeafrect])
  end if
end

on Exit08JenkinsLeaf
  if getaProp(getaProp(gObjects, #Leaf2Obj), #Aquired) <> #true then
    DelObjects([#JenkinsLeafrect])
  end if
end

on doJenkins2
  do("nothing")
  dontPassEvent()
end

on doFlylightrect
  set OBj to getaProp(getaProp(gObjects, #Flylight), #animator)
  if the pFrameRate of OBj < 120 then
    set the pFrameRate of OBj to the pFrameRate of OBj + 20
  else
    set the pFrameRate of OBj to 10
  end if
end

on DoGotoG11B
  set myChannel to playSound("G11log.aif", #keyframeCast)
  if gCPU = #mpc then
    set myTimer to the ticks
    repeat while the ticks < (myTimer + 15)
      CursorandUpdate()
    end repeat
  end if
  repeat while soundBusy(myChannel)
    CursorandUpdate()
  end repeat
  Jumptokey(#G11b)
end

on DoGoShort
  Jumptokey(#G11c)
end

on DoGoLong
  Jumptokey(#G11D)
end
